Index: gcc/jump.c
===================================================================
--- gcc.orig/jump.c
+++ gcc/jump.c
@@ -29,7 +29,8 @@ along with GCC; see the file COPYING3.  
    JUMP_LABEL internal field.  With this we can detect labels that
    become unused because of the deletion of all the jumps that
    formerly used them.  The JUMP_LABEL info is sometimes looked
-   at by later passes.
+   at by later passes.  For return insns, it contains either a
+   RETURN or a SIMPLE_RETURN rtx.
 
    The subroutines redirect_jump and invert_jump are used
    from other passes as well.  */
@@ -741,10 +742,10 @@ condjump_p (const_rtx insn)
     return (GET_CODE (x) == IF_THEN_ELSE
     && ((GET_CODE (XEXP (x, 2)) == PC
  && (GET_CODE (XEXP (x, 1)) == LABEL_REF
-     || GET_CODE (XEXP (x, 1)) == RETURN))
+     || ANY_RETURN_P (XEXP (x, 1))))
  || (GET_CODE (XEXP (x, 1)) == PC
     && (GET_CODE (XEXP (x, 2)) == LABEL_REF
- || GET_CODE (XEXP (x, 2)) == RETURN))));
+ || ANY_RETURN_P (XEXP (x, 2))))));
 }
 
 /* Return nonzero if INSN is a (possibly) conditional jump inside a
@@ -773,11 +774,11 @@ condjump_in_parallel_p (const_rtx insn)
     return 0;
   if (XEXP (SET_SRC (x), 2) == pc_rtx
       && (GET_CODE (XEXP (SET_SRC (x), 1)) == LABEL_REF
-  || GET_CODE (XEXP (SET_SRC (x), 1)) == RETURN))
+  || ANY_RETURN_P (XEXP (SET_SRC (x), 1)) == RETURN))
     return 1;
   if (XEXP (SET_SRC (x), 1) == pc_rtx
       && (GET_CODE (XEXP (SET_SRC (x), 2)) == LABEL_REF
-  || GET_CODE (XEXP (SET_SRC (x), 2)) == RETURN))
+  || ANY_RETURN_P (XEXP (SET_SRC (x), 2))))
     return 1;
   return 0;
 }
@@ -839,8 +840,9 @@ any_condjump_p (const_rtx insn)
   a = GET_CODE (XEXP (SET_SRC (x), 1));
   b = GET_CODE (XEXP (SET_SRC (x), 2));
 
-  return ((b == PC && (a == LABEL_REF || a == RETURN))
-  || (a == PC && (b == LABEL_REF || b == RETURN)));
+  return ((b == PC && (a == LABEL_REF || a == RETURN || a == SIMPLE_RETURN))
+  || (a == PC
+      && (b == LABEL_REF || b == RETURN || b == SIMPLE_RETURN)));
 }
 
 /* Return the label of a conditional jump.  */
@@ -877,6 +879,7 @@ returnjump_p_1 (rtx *loc, void *data ATT
   switch (GET_CODE (x))
     {
     case RETURN:
+    case SIMPLE_RETURN:
     case EH_RETURN:
       return true;
 
@@ -1199,7 +1202,7 @@ delete_related_insns (rtx insn)
   /* If deleting a jump, decrement the count of the label,
      and delete the label if it is now unused.  */
 
-  if (JUMP_P (insn) && JUMP_LABEL (insn))
+  if (JUMP_P (insn) && JUMP_LABEL (insn) && !ANY_RETURN_P (JUMP_LABEL (insn)))
     {
       rtx lab = JUMP_LABEL (insn), lab_next;
 
@@ -1330,6 +1333,18 @@ delete_for_peephole (rtx from, rtx to)
      is also an unconditional jump in that case.  */
 }
 
+/* A helper function for redirect_exp_1; examines its input X and returns
+   either a LABEL_REF around a label, or a RETURN if X was NULL.  */
+static rtx
+redirect_target (rtx x)
+{
+  if (x == NULL_RTX)
+    return ret_rtx;
+  if (!ANY_RETURN_P (x))
+    return gen_rtx_LABEL_REF (Pmode, x);
+  return x;
+}
+
 /* Throughout LOC, redirect OLABEL to NLABEL.  Treat null OLABEL or
    NLABEL as a return.  Accrue modifications into the change group.  */
 
@@ -1341,37 +1356,19 @@ redirect_exp_1 (rtx *loc, rtx olabel, rt
   int i;
   const char *fmt;
 
-  if (code == LABEL_REF)
-    {
-      if (XEXP (x, 0) == olabel)
- {
-  rtx n;
-  if (nlabel)
-    n = gen_rtx_LABEL_REF (Pmode, nlabel);
-  else
-    n = ret_rtx;
-
-  validate_change (insn, loc, n, 1);
-  return;
- }
-    }
-  else if (code == RETURN && olabel == 0)
+  if ((code == LABEL_REF && XEXP (x, 0) == olabel)
+      || x == olabel)
     {
-      if (nlabel)
- x = gen_rtx_LABEL_REF (Pmode, nlabel);
-      else
- x = ret_rtx;
-      if (loc == &PATTERN (insn))
- x = gen_rtx_SET (VOIDmode, pc_rtx, x);
-      validate_change (insn, loc, x, 1);
+      validate_change (insn, loc, redirect_target (nlabel), 1);
       return;
     }
 
-  if (code == SET && nlabel == 0 && SET_DEST (x) == pc_rtx
+  if (code == SET && SET_DEST (x) == pc_rtx
+      && ANY_RETURN_P (nlabel)
       && GET_CODE (SET_SRC (x)) == LABEL_REF
       && XEXP (SET_SRC (x), 0) == olabel)
     {
-      validate_change (insn, loc, ret_rtx, 1);
+      validate_change (insn, loc, nlabel, 1);
       return;
     }
 
@@ -1408,6 +1405,7 @@ redirect_jump_1 (rtx jump, rtx nlabel)
   int ochanges = num_validated_changes ();
   rtx *loc, asmop;
 
+  gcc_assert (nlabel);
   asmop = extract_asm_operands (PATTERN (jump));
   if (asmop)
     {
@@ -1429,17 +1427,20 @@ redirect_jump_1 (rtx jump, rtx nlabel)
    jump target label is unused as a result, it and the code following
    it may be deleted.
 
-   If NLABEL is zero, we are to turn the jump into a (possibly conditional)
-   RETURN insn.
+   Normally, NLABEL will be a label, but it may also be a RETURN or
+   SIMPLE_RETURN rtx; in that case we are to turn the jump into a
+   (possibly conditional) return insn.
 
    The return value will be 1 if the change was made, 0 if it wasn't
-   (this can only occur for NLABEL == 0).  */
+   (this can only occur when trying to produce return insns).  */
 
 int
 redirect_jump (rtx jump, rtx nlabel, int delete_unused)
 {
   rtx olabel = JUMP_LABEL (jump);
 
+  gcc_assert (nlabel != NULL_RTX);
+
   if (nlabel == olabel)
     return 1;
 
@@ -1451,7 +1452,7 @@ redirect_jump (rtx jump, rtx nlabel, int
 }
 
 /* Fix up JUMP_LABEL and label ref counts after OLABEL has been replaced with
-   NLABEL in JUMP.
+   NEW_DEST in JUMP.
    If DELETE_UNUSED is positive, delete related insn to OLABEL if its ref
    count has dropped to zero.  */
 void
@@ -1467,13 +1468,14 @@ redirect_jump_2 (rtx jump, rtx olabel, r
      about this.  */
   gcc_assert (delete_unused >= 0);
   JUMP_LABEL (jump) = nlabel;
-  if (nlabel)
+  if (nlabel && !ANY_RETURN_P (nlabel))
     ++LABEL_NUSES (nlabel);
 
   /* Update labels in any REG_EQUAL note.  */
   if ((note = find_reg_note (jump, REG_EQUAL, NULL_RTX)) != NULL_RTX)
     {
-      if (!nlabel || (invert && !invert_exp_1 (XEXP (note, 0), jump)))
+      if (ANY_RETURN_P (nlabel)
+  || (invert && !invert_exp_1 (XEXP (note, 0), jump)))
  remove_note (jump, note);
       else
  {
@@ -1482,7 +1484,8 @@ redirect_jump_2 (rtx jump, rtx olabel, r
  }
     }
 
-  if (olabel && --LABEL_NUSES (olabel) == 0 && delete_unused > 0
+  if (olabel && !ANY_RETURN_P (olabel)
+      && --LABEL_NUSES (olabel) == 0 && delete_unused > 0
       /* Undefined labels will remain outside the insn stream.  */
       && INSN_UID (olabel))
     delete_related_insns (olabel);
Index: gcc/print-rtl.c
===================================================================
--- gcc.orig/print-rtl.c
+++ gcc/print-rtl.c
@@ -314,9 +314,16 @@ print_rtx (const_rtx in_rtx)
       }
   }
  else if (i == 8 && JUMP_P (in_rtx) && JUMP_LABEL (in_rtx) != NULL)
-  /* Output the JUMP_LABEL reference.  */
-  fprintf (outfile, "\n%s%*s -> %d", print_rtx_head, indent * 2, "",
-   INSN_UID (JUMP_LABEL (in_rtx)));
+  {
+    /* Output the JUMP_LABEL reference.  */
+    fprintf (outfile, "\n%s%*s -> ", print_rtx_head, indent * 2, "");
+    if (GET_CODE (JUMP_LABEL (in_rtx)) == RETURN)
+      fprintf (outfile, "return");
+    else if (GET_CODE (JUMP_LABEL (in_rtx)) == SIMPLE_RETURN)
+      fprintf (outfile, "simple_return");
+    else
+      fprintf (outfile, "%d", INSN_UID (JUMP_LABEL (in_rtx)));
+  }
  else if (i == 0 && GET_CODE (in_rtx) == VALUE)
   {
 #ifndef GENERATOR_FILE
Index: gcc/reorg.c
===================================================================
--- gcc.orig/reorg.c
+++ gcc/reorg.c
@@ -161,8 +161,11 @@ static rtx *unfilled_firstobj;
 #define unfilled_slots_next \
   ((rtx *) obstack_next_free (&unfilled_slots_obstack))
 
-/* Points to the label before the end of the function.  */
-static rtx end_of_function_label;
+/* Points to the label before the end of the function, or before a
+   return insn.  */
+static rtx function_return_label;
+/* Likewise for a simple_return.  */
+static rtx function_simple_return_label;
 
 /* Mapping between INSN_UID's and position in the code since INSN_UID's do
    not always monotonically increase.  */
@@ -175,7 +178,7 @@ static int stop_search_p (rtx, int);
 static int resource_conflicts_p (struct resources *, struct resources *);
 static int insn_references_resource_p (rtx, struct resources *, bool);
 static int insn_sets_resource_p (rtx, struct resources *, bool);
-static rtx find_end_label (void);
+static rtx find_end_label (rtx);
 static rtx emit_delay_sequence (rtx, rtx, int);
 static rtx add_to_delay_list (rtx, rtx);
 static rtx delete_from_delay_slot (rtx);
@@ -220,6 +223,15 @@ static void relax_delay_slots (rtx);
 static void make_return_insns (rtx);
 #endif
 
+/* Return true iff INSN is a simplejump, or any kind of return insn.  */
+
+static bool
+simplejump_or_return_p (rtx insn)
+{
+  return (JUMP_P (insn)
+  && (simplejump_p (insn) || ANY_RETURN_P (PATTERN (insn))));
+}
+
 /* Return TRUE if this insn should stop the search for insn to fill delay
    slots.  LABELS_P indicates that labels should terminate the search.
    In all cases, jumps terminate the search.  */
@@ -335,23 +347,29 @@ insn_sets_resource_p (rtx insn, struct r
 
    ??? There may be a problem with the current implementation.  Suppose
    we start with a bare RETURN insn and call find_end_label.  It may set
-   end_of_function_label just before the RETURN.  Suppose the machinery
+   function_return_label just before the RETURN.  Suppose the machinery
    is able to fill the delay slot of the RETURN insn afterwards.  Then
-   end_of_function_label is no longer valid according to the property
+   function_return_label is no longer valid according to the property
    described above and find_end_label will still return it unmodified.
    Note that this is probably mitigated by the following observation:
-   once end_of_function_label is made, it is very likely the target of
+   once function_return_label is made, it is very likely the target of
    a jump, so filling the delay slot of the RETURN will be much more
    difficult.  */
 
 static rtx
-find_end_label (void)
+find_end_label (rtx kind)
 {
   rtx insn;
+  rtx *plabel;
+
+  if (kind == ret_rtx)
+    plabel = &function_return_label;
+  else
+    plabel = &function_simple_return_label;
 
   /* If we found one previously, return it.  */
-  if (end_of_function_label)
-    return end_of_function_label;
+  if (*plabel)
+    return *plabel;
 
   /* Otherwise, see if there is a label at the end of the function.  If there
      is, it must be that RETURN insns aren't needed, so that is our return
@@ -366,44 +384,44 @@ find_end_label (void)
 
   /* When a target threads its epilogue we might already have a
      suitable return insn.  If so put a label before it for the
-     end_of_function_label.  */
+     function_return_label.  */
   if (BARRIER_P (insn)
       && JUMP_P (PREV_INSN (insn))
-      && GET_CODE (PATTERN (PREV_INSN (insn))) == RETURN)
+      && PATTERN (PREV_INSN (insn)) == kind)
     {
       rtx temp = PREV_INSN (PREV_INSN (insn));
-      end_of_function_label = gen_label_rtx ();
-      LABEL_NUSES (end_of_function_label) = 0;
+      rtx label = gen_label_rtx ();
+      LABEL_NUSES (label) = 0;
 
       /* Put the label before an USE insns that may precede the RETURN insn.  */
       while (GET_CODE (temp) == USE)
  temp = PREV_INSN (temp);
 
-      emit_label_after (end_of_function_label, temp);
+      emit_label_after (label, temp);
+      *plabel = label;
     }
 
   else if (LABEL_P (insn))
-    end_of_function_label = insn;
+    *plabel = insn;
   else
     {
-      end_of_function_label = gen_label_rtx ();
-      LABEL_NUSES (end_of_function_label) = 0;
+      rtx label = gen_label_rtx ();
+      LABEL_NUSES (label) = 0;
       /* If the basic block reorder pass moves the return insn to
  some other place try to locate it again and put our
- end_of_function_label there.  */
-      while (insn && ! (JUMP_P (insn)
-        && (GET_CODE (PATTERN (insn)) == RETURN)))
+ function_return_label there.  */
+      while (insn && ! (JUMP_P (insn) && (PATTERN (insn) == kind)))
  insn = PREV_INSN (insn);
       if (insn)
  {
   insn = PREV_INSN (insn);
 
-  /* Put the label before an USE insns that may proceed the
+  /* Put the label before an USE insns that may precede the
      RETURN insn.  */
   while (GET_CODE (insn) == USE)
     insn = PREV_INSN (insn);
 
-  emit_label_after (end_of_function_label, insn);
+  emit_label_after (label, insn);
  }
       else
  {
@@ -413,19 +431,16 @@ find_end_label (void)
       && ! HAVE_return
 #endif
       )
-    {
-      /* The RETURN insn has its delay slot filled so we cannot
- emit the label just before it.  Since we already have
- an epilogue and cannot emit a new RETURN, we cannot
- emit the label at all.  */
-      end_of_function_label = NULL_RTX;
-      return end_of_function_label;
-    }
+    /* The RETURN insn has its delay slot filled so we cannot
+       emit the label just before it.  Since we already have
+       an epilogue and cannot emit a new RETURN, we cannot
+       emit the label at all.  */
+    return NULL_RTX;
 #endif /* HAVE_epilogue */
 
   /* Otherwise, make a new label and emit a RETURN and BARRIER,
      if needed.  */
-  emit_label (end_of_function_label);
+  emit_label (label);
 #ifdef HAVE_return
   /* We don't bother trying to create a return insn if the
      epilogue has filled delay-slots; we would have to try and
@@ -437,19 +452,21 @@ find_end_label (void)
       /* The return we make may have delay slots too.  */
       rtx insn = gen_return ();
       insn = emit_jump_insn (insn);
+      JUMP_LABEL (insn) = ret_rtx;
       emit_barrier ();
       if (num_delay_slots (insn) > 0)
  obstack_ptr_grow (&unfilled_slots_obstack, insn);
     }
 #endif
  }
+      *plabel = label;
     }
 
   /* Show one additional use for this label so it won't go away until
      we are done.  */
-  ++LABEL_NUSES (end_of_function_label);
+  ++LABEL_NUSES (*plabel);
 
-  return end_of_function_label;
+  return *plabel;
 }
 
 /* Put INSN and LIST together in a SEQUENCE rtx of LENGTH, and replace
@@ -797,10 +814,8 @@ optimize_skip (rtx insn)
   if ((next_trial == next_active_insn (JUMP_LABEL (insn))
        && ! (next_trial == 0 && crtl->epilogue_delay_list != 0))
       || (next_trial != 0
-  && JUMP_P (next_trial)
-  && JUMP_LABEL (insn) == JUMP_LABEL (next_trial)
-  && (simplejump_p (next_trial)
-      || GET_CODE (PATTERN (next_trial)) == RETURN)))
+  && simplejump_or_return_p (next_trial)
+  && JUMP_LABEL (insn) == JUMP_LABEL (next_trial)))
     {
       if (eligible_for_annul_false (insn, 0, trial, flags))
  {
@@ -819,13 +834,11 @@ optimize_skip (rtx insn)
  branch, thread our jump to the target of that branch.  Don't
  change this into a RETURN here, because it may not accept what
  we have in the delay slot.  We'll fix this up later.  */
-      if (next_trial && JUMP_P (next_trial)
-  && (simplejump_p (next_trial)
-      || GET_CODE (PATTERN (next_trial)) == RETURN))
+      if (next_trial && simplejump_or_return_p (next_trial))
  {
   rtx target_label = JUMP_LABEL (next_trial);
-  if (target_label == 0)
-    target_label = find_end_label ();
+  if (ANY_RETURN_P (target_label))
+    target_label = find_end_label (target_label);
 
   if (target_label)
     {
@@ -866,7 +879,7 @@ get_jump_flags (rtx insn, rtx label)
   if (JUMP_P (insn)
       && (condjump_p (insn) || condjump_in_parallel_p (insn))
       && INSN_UID (insn) <= max_uid
-      && label != 0
+      && label != 0 && !ANY_RETURN_P (label)
       && INSN_UID (label) <= max_uid)
     flags
       = (uid_to_ruid[INSN_UID (label)] > uid_to_ruid[INSN_UID (insn)])
@@ -1038,7 +1051,7 @@ get_branch_condition (rtx insn, rtx targ
     pat = XVECEXP (pat, 0, 0);
 
   if (GET_CODE (pat) == RETURN)
-    return target == 0 ? const_true_rtx : 0;
+    return ANY_RETURN_P (target) ? const_true_rtx : 0;
 
   else if (GET_CODE (pat) != SET || SET_DEST (pat) != pc_rtx)
     return 0;
@@ -1358,8 +1371,7 @@ steal_delay_list_from_fallthrough (rtx i
   /* We can't do anything if SEQ's delay insn isn't an
      unconditional branch.  */
 
-  if (! simplejump_p (XVECEXP (seq, 0, 0))
-      && GET_CODE (PATTERN (XVECEXP (seq, 0, 0))) != RETURN)
+  if (! simplejump_or_return_p (XVECEXP (seq, 0, 0)))
     return delay_list;
 
   for (i = 1; i < XVECLEN (seq, 0); i++)
@@ -2245,7 +2257,8 @@ fill_simple_delay_slots (int non_jumps_p
   && (!JUMP_P (insn)
       || ((condjump_p (insn) || condjump_in_parallel_p (insn))
   && ! simplejump_p (insn)
-  && JUMP_LABEL (insn) != 0)))
+  && JUMP_LABEL (insn) != 0
+  && !ANY_RETURN_P (JUMP_LABEL (insn)))))
  {
   /* Invariant: If insn is a JUMP_INSN, the insn's jump
      label.  Otherwise, zero.  */
@@ -2270,7 +2283,7 @@ fill_simple_delay_slots (int non_jumps_p
  target = JUMP_LABEL (insn);
     }
 
-  if (target == 0)
+  if (target == 0 || ANY_RETURN_P (target))
     for (trial = next_nonnote_insn (insn); trial; trial = next_trial)
       {
  next_trial = next_nonnote_insn (trial);
@@ -2349,6 +2362,7 @@ fill_simple_delay_slots (int non_jumps_p
       && JUMP_P (trial)
       && simplejump_p (trial)
       && (target == 0 || JUMP_LABEL (trial) == target)
+      && !ANY_RETURN_P (JUMP_LABEL (trial))
       && (next_trial = next_active_insn (JUMP_LABEL (trial))) != 0
       && ! (NONJUMP_INSN_P (next_trial)
     && GET_CODE (PATTERN (next_trial)) == SEQUENCE)
@@ -2371,7 +2385,7 @@ fill_simple_delay_slots (int non_jumps_p
       if (new_label != 0)
  new_label = get_label_before (new_label);
       else
- new_label = find_end_label ();
+ new_label = find_end_label (simple_return_rtx);
 
       if (new_label)
         {
@@ -2503,7 +2517,8 @@ fill_simple_delay_slots (int non_jumps_p
 
 /* Follow any unconditional jump at LABEL;
    return the ultimate label reached by any such chain of jumps.
-   Return null if the chain ultimately leads to a return instruction.
+   Return a suitable return rtx if the chain ultimately leads to a
+   return instruction.
    If LABEL is not followed by a jump, return LABEL.
    If the chain loops or we can't find end, return LABEL,
    since that tells caller to avoid changing the insn.  */
@@ -2518,6 +2533,7 @@ follow_jumps (rtx label)
 
   for (depth = 0;
        (depth < 10
+ && !ANY_RETURN_P (value)
  && (insn = next_active_insn (value)) != 0
  && JUMP_P (insn)
  && ((JUMP_LABEL (insn) != 0 && any_uncondjump_p (insn)
@@ -2527,18 +2543,22 @@ follow_jumps (rtx label)
  && BARRIER_P (next));
        depth++)
     {
-      rtx tem;
+      rtx this_label = JUMP_LABEL (insn);
 
       /* If we have found a cycle, make the insn jump to itself.  */
-      if (JUMP_LABEL (insn) == label)
+      if (this_label == label)
  return label;
 
-      tem = next_active_insn (JUMP_LABEL (insn));
-      if (tem && (GET_CODE (PATTERN (tem)) == ADDR_VEC
+      if (!ANY_RETURN_P (this_label))
+ {
+  rtx tem = next_active_insn (this_label);
+  if (tem
+      && (GET_CODE (PATTERN (tem)) == ADDR_VEC
   || GET_CODE (PATTERN (tem)) == ADDR_DIFF_VEC))
- break;
+    break;
+ }
 
-      value = JUMP_LABEL (insn);
+      value = this_label;
     }
   if (depth == 10)
     return label;
@@ -2985,16 +3005,14 @@ fill_slots_from_thread (rtx insn, rtx co
 
       gcc_assert (thread_if_true);
 
-      if (new_thread && JUMP_P (new_thread)
-  && (simplejump_p (new_thread)
-      || GET_CODE (PATTERN (new_thread)) == RETURN)
+      if (new_thread && simplejump_or_return_p (new_thread)
   && redirect_with_delay_list_safe_p (insn,
       JUMP_LABEL (new_thread),
       delay_list))
  new_thread = follow_jumps (JUMP_LABEL (new_thread));
 
-      if (new_thread == 0)
- label = find_end_label ();
+      if (ANY_RETURN_P (new_thread))
+ label = find_end_label (new_thread);
       else if (LABEL_P (new_thread))
  label = new_thread;
       else
@@ -3340,11 +3358,12 @@ relax_delay_slots (rtx first)
  group of consecutive labels.  */
       if (JUMP_P (insn)
   && (condjump_p (insn) || condjump_in_parallel_p (insn))
-  && (target_label = JUMP_LABEL (insn)) != 0)
+  && (target_label = JUMP_LABEL (insn)) != 0
+  && !ANY_RETURN_P (target_label))
  {
   target_label = skip_consecutive_labels (follow_jumps (target_label));
-  if (target_label == 0)
-    target_label = find_end_label ();
+  if (ANY_RETURN_P (target_label))
+    target_label = find_end_label (target_label);
 
   if (target_label && next_active_insn (target_label) == next
       && ! condjump_in_parallel_p (insn))
@@ -3359,9 +3378,8 @@ relax_delay_slots (rtx first)
   /* See if this jump conditionally branches around an unconditional
      jump.  If so, invert this jump and point it to the target of the
      second jump.  */
-  if (next && JUMP_P (next)
+  if (next && simplejump_or_return_p (next)
       && any_condjump_p (insn)
-      && (simplejump_p (next) || GET_CODE (PATTERN (next)) == RETURN)
       && target_label
       && next_active_insn (target_label) == next_active_insn (next)
       && no_labels_between_p (insn, next))
@@ -3376,7 +3394,7 @@ relax_delay_slots (rtx first)
  invert_jump fails.  */
 
       ++LABEL_NUSES (target_label);
-      if (label)
+      if (label && LABEL_P (label))
  ++LABEL_NUSES (label);
 
       if (invert_jump (insn, label, 1))
@@ -3385,7 +3403,7 @@ relax_delay_slots (rtx first)
   next = insn;
  }
 
-      if (label)
+      if (label && LABEL_P (label))
  --LABEL_NUSES (label);
 
       if (--LABEL_NUSES (target_label) == 0)
@@ -3403,8 +3421,7 @@ relax_delay_slots (rtx first)
  Don't do this if we expect the conditional branch to be true, because
  we would then be making the more common case longer.  */
 
-      if (JUMP_P (insn)
-  && (simplejump_p (insn) || GET_CODE (PATTERN (insn)) == RETURN)
+      if (simplejump_or_return_p (insn)
   && (other = prev_active_insn (insn)) != 0
   && any_condjump_p (other)
   && no_labels_between_p (other, insn)
@@ -3445,10 +3462,10 @@ relax_delay_slots (rtx first)
  Only do so if optimizing for size since this results in slower, but
  smaller code.  */
       if (optimize_function_for_size_p (cfun)
-  && GET_CODE (PATTERN (delay_insn)) == RETURN
+  && ANY_RETURN_P (PATTERN (delay_insn))
   && next
   && JUMP_P (next)
-  && GET_CODE (PATTERN (next)) == RETURN)
+  && PATTERN (next) == PATTERN (delay_insn))
  {
   rtx after;
   int i;
@@ -3487,14 +3504,16 @@ relax_delay_slots (rtx first)
  continue;
 
       target_label = JUMP_LABEL (delay_insn);
+      if (target_label && ANY_RETURN_P (target_label))
+ continue;
 
       if (target_label)
  {
   /* If this jump goes to another unconditional jump, thread it, but
      don't convert a jump into a RETURN here.  */
   trial = skip_consecutive_labels (follow_jumps (target_label));
-  if (trial == 0)
-    trial = find_end_label ();
+  if (ANY_RETURN_P (trial))
+    trial = find_end_label (trial);
 
   if (trial && trial != target_label
       && redirect_with_delay_slots_safe_p (delay_insn, trial, insn))
@@ -3517,7 +3536,7 @@ relax_delay_slots (rtx first)
  later incorrectly compute register live/death info.  */
       rtx tmp = next_active_insn (trial);
       if (tmp == 0)
- tmp = find_end_label ();
+ tmp = find_end_label (simple_return_rtx);
 
       if (tmp)
         {
@@ -3537,14 +3556,12 @@ relax_delay_slots (rtx first)
      delay list and that insn is redundant, thread the jump.  */
   if (trial && GET_CODE (PATTERN (trial)) == SEQUENCE
       && XVECLEN (PATTERN (trial), 0) == 2
-      && JUMP_P (XVECEXP (PATTERN (trial), 0, 0))
-      && (simplejump_p (XVECEXP (PATTERN (trial), 0, 0))
-  || GET_CODE (PATTERN (XVECEXP (PATTERN (trial), 0, 0))) == RETURN)
+      && simplejump_or_return_p (XVECEXP (PATTERN (trial), 0, 0))
       && redundant_insn (XVECEXP (PATTERN (trial), 0, 1), insn, 0))
     {
       target_label = JUMP_LABEL (XVECEXP (PATTERN (trial), 0, 0));
-      if (target_label == 0)
- target_label = find_end_label ();
+      if (ANY_RETURN_P (target_label))
+ target_label = find_end_label (target_label);
 
       if (target_label
           && redirect_with_delay_slots_safe_p (delay_insn, target_label,
@@ -3622,16 +3639,15 @@ relax_delay_slots (rtx first)
  a RETURN here.  */
       if (! INSN_ANNULLED_BRANCH_P (delay_insn)
   && any_condjump_p (delay_insn)
-  && next && JUMP_P (next)
-  && (simplejump_p (next) || GET_CODE (PATTERN (next)) == RETURN)
+  && next && simplejump_or_return_p (next)
   && next_active_insn (target_label) == next_active_insn (next)
   && no_labels_between_p (insn, next))
  {
   rtx label = JUMP_LABEL (next);
   rtx old_label = JUMP_LABEL (delay_insn);
 
-  if (label == 0)
-    label = find_end_label ();
+  if (ANY_RETURN_P (label))
+    label = find_end_label (label);
 
   /* find_end_label can generate a new label. Check this first.  */
   if (label
@@ -3692,7 +3708,8 @@ static void
 make_return_insns (rtx first)
 {
   rtx insn, jump_insn, pat;
-  rtx real_return_label = end_of_function_label;
+  rtx real_return_label = function_return_label;
+  rtx real_simple_return_label = function_simple_return_label;
   int slots, i;
 
 #ifdef DELAY_SLOTS_FOR_EPILOGUE
@@ -3710,15 +3727,22 @@ make_return_insns (rtx first)
      made for END_OF_FUNCTION_LABEL.  If so, set up anything we can't change
      into a RETURN to jump to it.  */
   for (insn = first; insn; insn = NEXT_INSN (insn))
-    if (JUMP_P (insn) && GET_CODE (PATTERN (insn)) == RETURN)
+    if (JUMP_P (insn) && ANY_RETURN_P (PATTERN (insn)))
       {
- real_return_label = get_label_before (insn);
+ rtx t = get_label_before (insn);
+ if (PATTERN (insn) == ret_rtx)
+  real_return_label = t;
+ else
+  real_simple_return_label = t;
  break;
       }
 
   /* Show an extra usage of REAL_RETURN_LABEL so it won't go away if it
      was equal to END_OF_FUNCTION_LABEL.  */
-  LABEL_NUSES (real_return_label)++;
+  if (real_return_label)
+    LABEL_NUSES (real_return_label)++;
+  if (real_simple_return_label)
+    LABEL_NUSES (real_simple_return_label)++;
 
   /* Clear the list of insns to fill so we can use it.  */
   obstack_free (&unfilled_slots_obstack, unfilled_firstobj);
@@ -3726,13 +3750,27 @@ make_return_insns (rtx first)
   for (insn = first; insn; insn = NEXT_INSN (insn))
     {
       int flags;
+      rtx kind, real_label;
 
       /* Only look at filled JUMP_INSNs that go to the end of function
  label.  */
       if (!NONJUMP_INSN_P (insn)
   || GET_CODE (PATTERN (insn)) != SEQUENCE
-  || !JUMP_P (XVECEXP (PATTERN (insn), 0, 0))
-  || JUMP_LABEL (XVECEXP (PATTERN (insn), 0, 0)) != end_of_function_label)
+  || !JUMP_P (XVECEXP (PATTERN (insn), 0, 0)))
+ continue;
+
+      if (JUMP_LABEL (XVECEXP (PATTERN (insn), 0, 0)) == function_return_label)
+ {
+  kind = ret_rtx;
+  real_label = real_return_label;
+ }
+      else if (JUMP_LABEL (XVECEXP (PATTERN (insn), 0, 0))
+       == function_simple_return_label)
+ {
+  kind = simple_return_rtx;
+  real_label = real_simple_return_label;
+ }
+      else
  continue;
 
       pat = PATTERN (insn);
@@ -3740,14 +3778,12 @@ make_return_insns (rtx first)
 
       /* If we can't make the jump into a RETURN, try to redirect it to the best
  RETURN and go on to the next insn.  */
-      if (! reorg_redirect_jump (jump_insn, NULL_RTX))
+      if (! reorg_redirect_jump (jump_insn, kind))
  {
   /* Make sure redirecting the jump will not invalidate the delay
      slot insns.  */
-  if (redirect_with_delay_slots_safe_p (jump_insn,
- real_return_label,
- insn))
-    reorg_redirect_jump (jump_insn, real_return_label);
+  if (redirect_with_delay_slots_safe_p (jump_insn, real_label, insn))
+    reorg_redirect_jump (jump_insn, real_label);
   continue;
  }
 
@@ -3787,7 +3823,7 @@ make_return_insns (rtx first)
  RETURN, delete the SEQUENCE and output the individual insns,
  followed by the RETURN.  Then set things up so we try to find
  insns for its delay slots, if it needs some.  */
-      if (GET_CODE (PATTERN (jump_insn)) == RETURN)
+      if (ANY_RETURN_P (PATTERN (jump_insn)))
  {
   rtx prev = PREV_INSN (insn);
 
@@ -3804,13 +3840,16 @@ make_return_insns (rtx first)
       else
  /* It is probably more efficient to keep this with its current
    delay slot as a branch to a RETURN.  */
- reorg_redirect_jump (jump_insn, real_return_label);
+ reorg_redirect_jump (jump_insn, real_label);
     }
 
   /* Now delete REAL_RETURN_LABEL if we never used it.  Then try to fill any
      new delay slots we have created.  */
-  if (--LABEL_NUSES (real_return_label) == 0)
+  if (real_return_label != NULL_RTX && --LABEL_NUSES (real_return_label) == 0)
     delete_related_insns (real_return_label);
+  if (real_simple_return_label != NULL_RTX
+      && --LABEL_NUSES (real_simple_return_label) == 0)
+    delete_related_insns (real_simple_return_label);
 
   fill_simple_delay_slots (1);
   fill_simple_delay_slots (0);
@@ -3878,7 +3917,7 @@ dbr_schedule (rtx first)
   init_resource_info (epilogue_insn);
 
   /* Show we haven't computed an end-of-function label yet.  */
-  end_of_function_label = 0;
+  function_return_label = function_simple_return_label = NULL_RTX;
 
   /* Initialize the statistics for this function.  */
   memset (num_insns_needing_delays, 0, sizeof num_insns_needing_delays);
@@ -3900,11 +3939,23 @@ dbr_schedule (rtx first)
   /* If we made an end of function label, indicate that it is now
      safe to delete it by undoing our prior adjustment to LABEL_NUSES.
      If it is now unused, delete it.  */
-  if (end_of_function_label && --LABEL_NUSES (end_of_function_label) == 0)
-    delete_related_insns (end_of_function_label);
+  if (function_return_label && --LABEL_NUSES (function_return_label) == 0)
+    delete_related_insns (function_return_label);
+  if (function_simple_return_label
+      && --LABEL_NUSES (function_simple_return_label) == 0)
+    delete_related_insns (function_simple_return_label);
 
+#if defined HAVE_return || defined HAVE_simple_return
+  if (
 #ifdef HAVE_return
-  if (HAVE_return && end_of_function_label != 0)
+      (HAVE_return && function_return_label != 0)
+#else
+      0
+#endif
+#ifdef HAVE_simple_return
+      || (HAVE_simple_return && function_simple_return_label != 0)
+#endif
+      )
     make_return_insns (first);
 #endif
 
Index: gcc/resource.c
===================================================================
--- gcc.orig/resource.c
+++ gcc/resource.c
@@ -495,6 +495,8 @@ find_dead_or_set_registers (rtx target,
   || GET_CODE (PATTERN (this_jump_insn)) == RETURN)
  {
   next = JUMP_LABEL (this_jump_insn);
+  if (next && ANY_RETURN_P (next))
+    next = NULL_RTX;
   if (jump_insn == 0)
     {
       jump_insn = insn;
@@ -562,9 +564,10 @@ find_dead_or_set_registers (rtx target,
   AND_COMPL_HARD_REG_SET (scratch, needed.regs);
   AND_COMPL_HARD_REG_SET (fallthrough_res.regs, scratch);
 
-  find_dead_or_set_registers (JUMP_LABEL (this_jump_insn),
-      &target_res, 0, jump_count,
-      target_set, needed);
+  if (!ANY_RETURN_P (JUMP_LABEL (this_jump_insn)))
+    find_dead_or_set_registers (JUMP_LABEL (this_jump_insn),
+ &target_res, 0, jump_count,
+ target_set, needed);
   find_dead_or_set_registers (next,
       &fallthrough_res, 0, jump_count,
       set, needed);
@@ -1097,6 +1100,8 @@ mark_target_live_regs (rtx insns, rtx ta
       struct resources new_resources;
       rtx stop_insn = next_active_insn (jump_insn);
 
+      if (jump_target && ANY_RETURN_P (jump_target))
+ jump_target = NULL_RTX;
       mark_target_live_regs (insns, next_active_insn (jump_target),
      &new_resources);
       CLEAR_RESOURCE (&set);
Index: gcc/rtl.c
===================================================================
--- gcc.orig/rtl.c
+++ gcc/rtl.c
@@ -256,6 +256,7 @@ copy_rtx (rtx orig)
     case PC:
     case CC0:
     case RETURN:
+    case SIMPLE_RETURN:
     case SCRATCH:
       /* SCRATCH must be shared because they represent distinct values.  */
       return orig;
